#!/usr/bin/perl
#this is based on get_allelels.pl, but will also return the allele frequency for each allele and it will not record snps for which
# N is the only alternative allele! 
# written by norman warthmann, september 2005 

use strict;
use Bio::AlignIO;
use Bio::PopGen::Utilities;
use Bio::PopGen::PopulationI;
use Bio::PopGen::MarkerI;
use File::Basename;

my $chromosome=$ARGV[1];


#set the blank alleles variable default is [\s\-N\?]:
#print $Bio::PopGen::Genotype::BlankAlleles;
$Bio::PopGen::Genotype::BlankAlleles='[\s\?]'; # I want the N's and dashes to be annotated!
#$Bio::PopGen::Genotype::BlankAlleles='[\s\?N]';


## create Bio::SimpleAlign object

my $in;
my $out;
my $inputfilename=$ARGV[0];
my $fragname=basename($inputfilename);

$in  = Bio::AlignIO->new(-file => $inputfilename , '-format' => 'fasta');
my $aln;
   																										#$out = Bio::AlignIO->new(-file => ">$inputfilename.out" , '-format' => 'pfam');
   			
while ($aln = $in->next_aln()) {
    																									#$out->write_aln($aln);
	my $population = Bio::PopGen::Utilities->aln_to_population(	-alignment	=> $aln,
    															-site_model	=> 'all',
    															-include_monomorphic => 0);
    	
  	my @marker_names = $population->get_marker_names;
	foreach my $markername (@marker_names){
		my $marker = $population->get_Marker($markername); 
		my @diff_alleles = $marker->get_Alleles(); #which different alleles are there?
		if ((scalar(@diff_alleles) ==2) && (($diff_alleles[0] eq "N") || ($diff_alleles[1] eq "N"))) { 		#throw out if there is only exactly 2 alleles and one of them is N!! ;-)
																											#print $markername,"\t", join ("\t",@diff_alleles) ."\n"
		}
		else{
 			my %af = $marker->get_Allele_Frequencies;
  			foreach my $genotype ( $population->get_Genotypes(-marker => $markername) ) {
      			$markername=~s/Site-//; 																	#the standard markername has a prefix I do not want!
      			my @alleles=$genotype->get_Alleles(); 														#in this case per definition it can oly be ONE allele!
      			print $fragname."-".$markername ,"\t", $genotype->individual_id, "\t", 	#inputfilename+markername should exactly add up to the position in the genome, because the markernames starts at 0 ;-)
      			join(',', @alleles), "\t", $fragname, "\t"; 											# you could very well print just print @alleles, without join.
 																											#print "$af{$frequ[0]}\n";
 				print sprintf ("%.2f", $af{$alleles[0]}) ."\n"; 											#$gerundete_zahl = sprintf ("%.2f", $ungerundete_zahl);
 			}
																			#foreach my $allele ( keys %af ) { #print the allele freuency for each allele after each marker
																			#print "\t\t\t\t\t$allele $af{$allele}\n";
 																			#}
		}
	}  
}


#
#\COPY arabis_alpina.snps(position_name, ecotype, replacement, frag_id, allele_freq) FROM  'path to datafile';
#psql msqt -U msqt -c "\COPY arabis_alpina.snps(position_name, ecotype, replacement, frag_id, allele_freq) FROM  '/.amd_mnt/abt6-xserve/Users/norman/path to datafile'"
#

