#!/usr/bin/perl
#this is based on get_allelels.pl, 
# it will return the table for reference
# written by norman warthmann, september 2005 

use strict;
use Bio::AlignIO;
use Bio::PopGen::Utilities;
use Bio::PopGen::PopulationI;
use Bio::PopGen::MarkerI;
use File::Basename;

my $chromosome=$ARGV[1];


#set the blank alleles variable default is [\s\-N\?]:
#print $Bio::PopGen::Genotype::BlankAlleles;
$Bio::PopGen::Genotype::BlankAlleles='[\s\?]'; # I want the N's and dashes to be annotated!
#$Bio::PopGen::Genotype::BlankAlleles='[\s\?N]';


## create Bio::SimpleAlign object

my $in;
my $out;
my $inputfilename=$ARGV[0];
my $fragname=basename($inputfilename);

$in  = Bio::AlignIO->new(-file => $inputfilename , '-format' => 'fasta');
my $aln;
   																										#$out = Bio::AlignIO->new(-file => ">$inputfilename.out" , '-format' => 'pfam');
   			
while ($aln = $in->next_aln()) {
    																									#$out->write_aln($aln);
	my $population2 = Bio::PopGen::Utilities->aln_to_population(	-alignment	=> $aln,
    															-site_model	=> 'all',
    															-include_monomorphic => 1);
    	
  	my @marker_names = $population2->get_marker_names;
	foreach my $markername (@marker_names){
		my $marker = $population2->get_Marker($markername); 
		foreach my $genotype ( $population2->get_Genotypes(-marker => $markername) ) {
      		if 	($genotype->individual_id eq 'target') {
      			$markername=~s/Site-//; 																	#the standard markername has a prefix I do not want!
      			my @alleles=$genotype->get_Alleles(); 														#in this case per definition it can oly be ONE allele!
      			print $chromosome, "\t", $fragname+$markername ,"\t",
      			join(',', @alleles), "\t", $fragname, "\n"; 											# you could very well print just print @alleles, without join.
 				} else {};
 		
																			#foreach my $allele ( keys %af ) { #print the allele freuency for each allele after each marker
																			#print "\t\t\t\t\t$allele $af{$allele}\n";
 																			#}
		}
	}  
}

#\COPY nordborg_99.target_sequences(chromosome, position, ref-base, frag_id) FROM  'path to file';
#psql msqt -U msqt -c "\COPY nordborg_99.target_sequences(chromosome, position, ref_base, frag_id) FROM  '/.amd_mnt/abt6-xserve/Users/norman/target_sequence_table.txt'"

