------------------------------------------------------------------------
-- File: setup_msqtconfig.sql
-- Author: Joffrey Fitz
-- Usage:
--   psql -U postgres msqtpublic < ./setup_msqtconfig.sql
------------------------------------------------------------------------

------------------------------------------------------------------------
-- Create configuration table in schema public
--
-- Example values:
--
-- "arabis_alpina";"struct_position_name";""
-- "guppy";"struct_position_name";""
-- "misc";"struct_position_name";""
-- "nordborg_99";"struct_position_chromosome";"5"
------------------------------------------------------------------------
CREATE TABLE msqt_config
(
  msqt_schema_name varchar(255) NOT NULL,
  msqt_schema_type varchar(255) NOT NULL,
  chromosomes int2,
  uploaded_archive varchar(255) NOT NULL,
  population_date date NOT NULL,
  default_dataset bool NOT NULL DEFAULT false,
  s4s_diff_threshold varchar,
  s4s_left_neigbh_threshold varchar,
  s4s_right_neigbh_threshold varchar,
  CONSTRAINT msqt_config_pkey PRIMARY KEY (msqt_schema_name)
) 
WITH OIDS;
ALTER TABLE msqt_config OWNER TO msqt;
GRANT ALL ON TABLE msqt_config TO msqt;
GRANT SELECT ON TABLE msqt_config TO msqtwebuser;
