#!/usr/bin/perl -w

#
# msqt-alivie.cgi
#
# Author: Joffrey Fitz <fitzj@informatik.uni-tuebingen.de>
#
# Copyright (c) 2007 Max Planck Institute for Developmental Biology, 
# 	http://www.eb.tuebingen.mpg.de
#
# This program is part of the MSQT project by Norman Warthmann, Joffrey Fitz 
# and Detlef Weigel (http://msqt.weigelworld.org)
#
# This program is free software; you can redistribute it and/or modify it                        
# under the terms of the GNU General Public License as published by the Free                     
# Software Foundation; either version 2, or (at your option) any later 
# version.
#
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
# for more details.
#

use strict;
use CGI;
use CGI::Carp qw( fatalsToBrowser );
use DBI;
use LWP::Simple;

# global
my $DEBUG = 0;
# CGI
my $script_loc = "[msqtcgiroot]/msqt-alivie.cgi";
# GUI templates
my $template_file = "html/msqt-alivie.html";
# Fasta files

my $fasta_base_url = "[msqtwebroot]/fasta_files/";

# Jalview
# Alivie
my $alivie_link = "[msqtcgiroot]/alivie0.4.cgi?file=";

# database config
my $dbname = "[DBNAME]";
my $host = "[DBHOST]";
my $port = "[DBPORT]";
my $options = "";
my $username = "msqt";
my $password = "[DBPASS]";

my $dbh;
my $sth;
my $row;
my $query;

####################################################################

$dbh = DBI->connect("dbi:Pg:dbname=$dbname;host=$host;port=$port;".
	"", "$username", "$password",
        {AutoCommit => 0} ) || db_connect_error();

msqt_alivie();

####################################################################


sub msqt_alivie {
        my $schema_type;

	print "Content-type: text/html\n\n";


        # get parameters
	my $q = new CGI;
	my $dbtable = $q->param( "dbtable" );
	my $frag_id = $q->param( "frag_id" );
	my $chr = $q->param( "chr" );


        # Determine which database structure is used
        $query = "SELECT msqt_schema_type FROM public.msqt_config WHERE msqt_schema_name = '$dbtable'";
        $sth = $dbh->prepare( $query );
        $sth->execute() || print "<font color=red><b>" . $sth->errstr . "</b></font><br><br>";
        while ( $row = $sth->fetchrow ) {
          $schema_type = $row;
        }


	my $file_buf;
	open FORM, $template_file or die $!;
	# read template
	while(<FORM>) {
		$file_buf .= $_;
	}

	$file_buf =~ s/<!--fragid-->/$frag_id/g;


        if($schema_type eq "struct_position_chromosome") {
          $alivie_link .= "$fasta_base_url/$dbtable/chromosome_$chr/$frag_id";
        }
        elsif($schema_type eq "struct_position_name") {
          $alivie_link .= "$fasta_base_url/$dbtable/$frag_id";
        }
        else {
          die ("configuration error: no template found for $dbtable ($row).")
        }

	my $alignment = get $alivie_link;
# 	print $alignment;
# 	exit;
	
	$file_buf =~ s/<!--alivie-->/$alignment/;

	print $file_buf;
	close FORM;
}


