#!/usr/bin/perl
# snipe4snps CGI wrapper

#
# sniped_stream2.cgi
#
# Author: Joffrey Fitz <fitzj@informatik.uni-tuebingen.de>
#
# Copyright (c) 2007 Max Planck Institute for Developmental Biology, 
# 	http://www.eb.tuebingen.mpg.de
#
# This program is part of the MSQT project by Norman Warthmann, Joffrey Fitz 
# and Detlef Weigel (http://msqt.weigelworld.org)
#
# This program is free software; you can redistribute it and/or modify it                        
# under the terms of the GNU General Public License as published by the Free                     
# Software Foundation; either version 2, or (at your option) any later 
# version.
#
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
# for more details.
#

use CGI;
use CGI::Carp qw( fatalsToBrowser );

my $q = new CGI();
my $schema = $q->param('schema');
my $schema_type = $q->param('schema_type');
my $div_threshold = $q->param('div_threshold');
my $right_neigbh_threshold = $q->param('right_neigbh_threshold');
my $left_neigbh_threshold = $q->param('left_neigbh_threshold');
	
# die $ENV{QUERY_STRING};

die "!! no schema" if($schema eq "");
die "!! no div_threshold" if($div_threshold eq "");
die "!! no right_neigbh_threshold" if($right_neigbh_threshold eq "");
die "!! no left_neigbh_threshold" if($left_neigbh_threshold eq "");

my $prog;
if($schema_type eq "struct_position_chromosome") {
	$prog = "./snipe4snps_chrpos.pl";
}
elsif($schema_type eq "struct_position_name") {
	$prog = "./snipe4snps_posname.pl";
}
else {
	die "!! wrong schema_type: $schema_type";
}

$cmd = "$prog $schema $div_threshold $right_neigbh_threshold $left_neigbh_threshold";

my $pid = open(PH, "$cmd 2>&1 |") or die "Cant run cmd '$cmd':\n $!";
select(STDOUT); 
$| = 1;     # make unbuffered


$header="Content-type: multipart/x-mixed-replace;" . "boundary=***Boundary_String***\n";
$boundary="\n--***Boundary_String***\n";

print $header;
print $boundary;

$content_type = "Content-type: text/html\n\n";

while(<PH>) {
	print $content_type;
	print "$_<br>\n";
	print $boundary;
#sleep(1);
}

# sleep($waitsec);
